#ifndef MSP_IO_SEEKABLE_H_
#define MSP_IO_SEEKABLE_H_

#include "base.h"

namespace Msp {
namespace IO {

class Handle;

#ifdef MSVC
typedef __int64 SeekOffset;
#else
typedef long long SeekOffset;
#endif

enum SeekType
{
	S_BEG,
	S_CUR,
	S_END
};


class Seekable: public Base
{
protected:
	Seekable() { }

public:
	/** Changes the read/write offset.  Returns the new offset. */
	virtual SeekOffset seek(SeekOffset, SeekType) = 0;
	
	/** Returns the current read/write offset. */
	virtual SeekOffset tell() const = 0;
};


SeekOffset sys_seek(Handle &, SeekOffset, SeekType);

} // namespace IO
} // namespace Msp

#endif
